#include "testlib.h"

const int MAXLEN = 100;
const int MAXN = 100;
const int MAXK = 1000;
const int MAXSUM = 1000;

int main(int argc, char* argv[])
{
  registerValidation(argc, argv);
  int n = inf.readInt(1, MAXN, "n");
  inf.readEoln();
  int sum = 0;
  for (int i = 0; i < n; i++) {
    std::string dictWord = inf.readToken();
    inf.readEoln();
    ensure(1 <= dictWord.size() && dictWord.size() <= MAXN);
    for (char dictC : dictWord) {
      ensure('a' <= dictC && dictC <= 'z');
    }
    sum += dictWord.size();
    ensure(sum <= MAXSUM);
  }
  if (n == 0) {
      inf.readEoln();
  }
  std::string s = inf.readToken();
  inf.readEoln();
  ensure(1 <= s.size() && s.size() <= MAXLEN);
  for (char c : s) {
    ensure('a' <= c && c <= 'z');
  }
  inf.readInt(1, MAXK, "k");
  inf.readEoln();
  inf.readEof();
  return 0;
}
