#include "bits/stdc++.h"
#define puba push_back
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }
const int MOD = 1e9 + 7;

struct node {
    vector<int> go;
    set<int> here;
    bool flag;
    node() : go(26, -1), flag(false) {}
};

vector<node> trie;

int add_node() {
    trie.puba(node());
    return szof(trie) - 1;
}

const int MAXL = 105;
char buf[MAXL];

const int MAXN = 2005;
int d[2][MAXN];

void add(int& a, int b) {
    a = a + b >= MOD ? a + b - MOD : a + b;
}

vector<vector<int>> graph;

int main() {
    //freopen(TASK_NAME ".in", "r", stdin);
    //freopen(TASK_NAME ".out", "w", stdout);
    cerr << fixed << setprecision(15);
    cout << fixed << setprecision(15);
    
    int n;
    scanf("%d", &n);

    add_node();
    vector<int> end;
    for (int i = 0; i < n; ++i) {
        scanf("%s", buf);
        int now = 0;
        for (int j = 0; buf[j]; ++j) {
            if (trie[now].go[buf[j] - 'a'] == -1) {
                trie[now].go[buf[j] - 'a'] = add_node();
            }
            now = trie[now].go[buf[j] - 'a'];
            if (buf[j + 1]) {
                trie[now].here.insert(i);
                while (szof(trie[now].here) > 3) {
                    trie[now].here.erase(--trie[now].here.end());
                }
            }
        }
        end.puba(now);
    }
    
    scanf("%s", buf);
    int now = 0;
    for (int i = 0; buf[i]; ++i) {
        if (trie[now].go[buf[i] - 'a'] == -1) {
            trie[now].go[buf[i] - 'a'] = add_node();
        }
        now = trie[now].go[buf[i] - 'a'];
        trie[now].flag = true;
    }
    int t = now;

    int k;
    scanf("%d", &k);

    graph = vector<vector<int>>(szof(trie));
    for (int i = 0; i < szof(trie); ++i) {
        for (int j = 0; j < 26; ++j) {
            if (trie[i].go[j] != -1) {
                if (trie[trie[i].go[j]].flag) {
                    graph[i].puba(trie[i].go[j]);
                }
                graph[trie[i].go[j]].puba(i);
            }
        }
        for (int num : trie[i].here) {
            graph[i].puba(end[num]);
        }
    }

    int ans = 0;
    d[1][0] = 1;
    for (int i = 0; i < k; ++i) {
        fill(d[i & 1], d[i & 1] + szof(graph), 0);
        for (int j = 0; j < szof(graph); ++j) {
            for (int to : graph[j]) {
                add(d[i & 1][to], d[1 - (i & 1)][j]);
            }
        }
        add(ans, d[i & 1][t]);
    }

    cout << ans << "\n";

    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}