import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Scanner;

public class Main {

    private static final long INF = (1L << 61L);
    private static final long TWO_SIXTY = (1L << 60L);

    public static void main(String[] args) {
        Scanner scn = new Scanner(System.in);
        PrintWriter pw = new PrintWriter(System.out);
        long a = scn.nextLong();
        long b = scn.nextLong();
        BigInteger ans = BigInteger.valueOf(-1);
        if (a != 0L || b != 0L) {
            ans = calc(BigInteger.valueOf(-a), BigInteger.valueOf(TWO_SIXTY + 1L));
            BigInteger tmp = calc(BigInteger.valueOf(b), BigInteger.valueOf(TWO_SIXTY - 1L));
            if (tmp.compareTo(ans) < 0) {
                ans = tmp;
            }
            if (ans.equals(BigInteger.valueOf(INF))) {
                ans = BigInteger.valueOf(-1);
            }
        }
        pw.println(ans);
        pw.close();

    }

    private static BigInteger calc(BigInteger a, BigInteger b) {
        if (a.equals(BigInteger.ZERO)) {
            return BigInteger.valueOf(INF);
        }
        return a.add(b).subtract(BigInteger.ONE).divide(a);
    }
}