#include "bits/stdc++.h"
#define puba push_back
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }

set<tuple<ll, ll, ll>> used;

int dfs(ll a, ll b, ll c) {
    used.insert(make_tuple(a, b, c));
    if (a >= 2 && !used.count(make_tuple(a - 2, b + 1, c + 1))) {
        dfs(a - 2, b + 1, c + 1);
    }
    if (b >= 2 && !used.count(make_tuple(a + 1, b - 2, c + 1))) {
        dfs(a + 1, b - 2, c + 1);
    }
    if (c >= 2 && !used.count(make_tuple(a + 1, b + 1, c - 2))) {
        dfs(a + 1, b + 1, c - 2);
    }
    return 0;
}

int main() {
    //freopen(TASK_NAME ".in", "r", stdin);
    //freopen(TASK_NAME ".out", "w", stdout);
    cerr << fixed << setprecision(15);
    cout << fixed << setprecision(15);
    
    /*
    a -= 1
    b -= 1
    c += 2
    
    a -= 1
    b += 2
    c -= 1
    
    a += 2
    b -= 1
    c -= 1
    */
    
    int t;
    scanf("%d", &t);
    for (int i = 0; i < t; ++i) {
        int a, b, c;
        scanf("%d%d%d", &a, &b, &c);
        if (!used.count(make_tuple(0, 0, (ll) a + b + c))) {
            dfs(0, 0, (ll) a + b + c);
            dfs(0, (ll) a + b + c, 0);
            dfs((ll) a + b + c, 0, 0);
        }
        if (used.count(make_tuple(a, b, c))) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
    
    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}