#include "bits/stdc++.h"
#define puba push_back
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }

map<tuple<int, int, int>, int> used;

int dfs(int a, int b, int c) {
	assert(a >= 0 && b >= 0 && c >= 0);
	if (a + b + c == max(max(a, b), c)) {
		return 1;
	}
	if (used.count(make_tuple(a, b, c))) {
		return used[make_tuple(a, b, c)];
	}
	auto& val = used[make_tuple(a, b, c)];
	if (a && b && !used.count(make_tuple(a - 1, b - 1, c + 2))) {
		if (dfs(a - 1, b - 1, c + 2)) {
			return val = 1;
		}
	}
	if (a && c && !used.count(make_tuple(a - 1, b + 2, c - 1))) {
		if (dfs(a - 1, b + 2, c - 1)) {
			return val = 1;
		}
	}
	if (b && c && !used.count(make_tuple(a + 2, b - 1, c - 1))) {
		if (dfs(a + 2, b - 1, c - 1)) {
			return val = 1;
		}
	}
	return 0;
}

int main() {
    //freopen(TASK_NAME ".in", "r", stdin);
    //freopen(TASK_NAME ".out", "w", stdout);
    cerr << fixed << setprecision(15);
    cout << fixed << setprecision(15);
    
    /*
    a -= 1
    b -= 1
    c += 2
    
    a -= 1
    b += 2
    c -= 1
    
    a += 2
    b -= 1
    c -= 1
    */
    
    int t;
    scanf("%d", &t);
    for (int i = 0; i < t; ++i) {
        int a, b, c;
        scanf("%d%d%d", &a, &b, &c);
        
        if (dfs(a, b, c)) {
        	cout << "Yes\n";
       	} else {
    		cout << "No\n";
    	}
    	
	}
    
    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}