#include "bits/stdc++.h"
#define puba push_back
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }
const int MAXN = 1e6 + 5;
vector<int> graph[MAXN];
int sz[MAXN];
const int SZ = 10;

ll cost[SZ][SZ];
int from[1 << SZ];
ll d[1 << SZ];
ll sum_by_mask[SZ][(1 << SZ) + 3];
int ind[(1 << SZ) + 3];

ll ans = 0;

vector<int> dfs(int v) {
    vector<vector<int>> children;
    for (int to : graph[v]) {
        children.puba(dfs(to));
    }
    int bpv = 1 << szof(graph[v]);
    for (int i = 0; i < szof(graph[v]); ++i) {
        for (int j = 0; j < szof(graph[v]); ++j) {
            if (i == j) {
                continue;
            }
            ll cnt = 0;
            for (int num1 : children[i]) {
                for (int num2 : children[j]) {
                    if (num1 > num2) {
                        ++cnt;
                    }
                }
            }
            cost[i][j] = cnt;
        }
        /*
        for (int j = 1; j < bpv; ++j) {
            int any = j & (-j);
            sum_by_mask[i][j] = sum_by_mask[i][j ^ any] + cost[i][ind[any]];
        }
        */
    }
    /*
    cerr << v << ":" << endl;
    for (int i = 0; i < szof(graph[v]); ++i) {
        for (int j = 0; j < szof(graph[v]); ++j) {
            cerr << cost[i][j] << " ";
        }
        cerr << endl;
    }
    */
    fill(d, d + bpv, INFL);
    d[0] = 0;
    for (int i = 0; i < bpv; ++i) {
        for (int j = 0; j < szof(graph[v]); ++j) {
            if (!((1 << j) & i)) {
                ll val = d[i];
                for (int k = 0; k < szof(graph[v]); ++k) {
                    if ((1 << k) & i) {
                        val += cost[k][j];
                    }
                }
                if (d[i | (1 << j)] > val) {
                    d[i | (1 << j)] = val;
                    from[i | (1 << j)] = i;
                }
            }
        }
    }
    //cerr << d[bpv - 1] << endl;
    ans += d[bpv - 1];
    int pos = bpv - 1;
    vector<int> newc(szof(graph[v]));
    int c = szof(graph[v]) - 1;
    while (pos) {
        newc[c] = graph[v][ind[pos ^ from[pos]]];
        --c;
        pos = from[pos];
    }
    graph[v] = newc;
    vector<int> all;
    for (auto& arr : children) {
        for (int num : arr) {
            if (num > v) {
                ++ans;
            }
            
            all.puba(num);
        }
    }
    all.puba(v);
    return all;
}

int main() {
    //freopen(TASK_NAME ".in", "r", stdin);
    //freopen(TASK_NAME ".out", "w", stdout);
    cerr << fixed << setprecision(15);
    cout << fixed << setprecision(15);
    
    for (int i = 0; i < SZ; ++i) {
        ind[1 << i] = i;
    }

    int n, root;
    scanf("%d%d", &n, &root);
    --root;

    for (int i = 0; i < n; ++i) {
        int num;
        scanf("%d", &num);
        for (int j = 0; j < num; ++j) {
            int v;
            scanf("%d", &v);
            --v;
            graph[i].puba(v);
        }
    }
    
    dfs(root);

    cout << ans << "\n";
    for (int i = 0; i < n; ++i) {
        cout << szof(graph[i]) << " ";
        for (int to : graph[i]) {
            cout << to + 1 << " ";
        }
        cout << "\n";
    }
    
    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}