#include "bits/stdc++.h"
#define puba push_back
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }
const int MAXN = 1e6 + 5;

vector<int> graph[MAXN];

ll calc(vector<int>& v) {
    ll ret = 0;
    for (int i = 0; i < szof(v); ++i) {
        for (int j = i + 1; j < szof(v); ++j) {
            if (v[i] > v[j]) {
                ++ret;
            }
        }
    }
    return ret;
}

vector<int> dfs(int v) {
    if (!szof(graph[v])) {
        return {v};
    }
    vector<vector<int>> children;
    for (int to : graph[v]) {
        children.puba(dfs(to));
    }
    vector<int> order;
    for (int i = 0; i < szof(graph[v]); ++i) {
        order.puba(i);
    }
    ll best = INFL;
    vector<int> mem;
    vector<int> memp;
    do {
        vector<int> cur;
        for (int i : order) {
            for (int num : children[i]) {
                cur.puba(num);
            }
        }
        ll val = calc(cur);
        if (val < best) {
            best = val;
            mem = cur;
            memp = order;
        }
    } while (next_permutation(bend(order)));
    mem.puba(v);
    vector<int> tmp;
    for (int i : memp) {
        tmp.puba(graph[v][i]);
    }
    graph[v] = tmp;
    return mem;
}

int main() {
    //freopen(TASK_NAME ".in", "r", stdin);
    //freopen(TASK_NAME ".out", "w", stdout);
    cerr << fixed << setprecision(15);
    cout << fixed << setprecision(15);
    
    int n, root;
    scanf("%d%d", &n, &root);
    --root;
    
    for (int i = 0; i < n; ++i) {
        int num;
        scanf("%d", &num);
        for (int j = 0; j < num; ++j) {
            int v;
            scanf("%d", &v);
            --v;
            graph[i].puba(v);
        }
    }
    
    auto res = dfs(root);

    cout << calc(res) << "\n";

    for (int i = 0; i < n; ++i) {
        cout << szof(graph[i]) << " ";
        for (int to : graph[i]) {
            cout << to + 1 << " ";
        }
        cout << "\n";
    }
    
    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}