#include "testlib.h"

using namespace std;

int main(int argc, char* argv[])
{
    registerValidation(argc, argv);
    string s = inf.readToken();
    if (s.size() == 0 || s.size() >= 100 || s == "0") {
        inf.quitf(_fail, "number too long or empty");
    }
    bool nonzero = false;
    for (char c : s) {
        if (!isdigit(c)) inf.quitf(_fail, "invalid character");

        if (c != '0') nonzero = true;
    }
    if (!nonzero) inf.quitf(_fail, "zero");
    inf.readEoln();
    inf.readEof();
}