//#include "grader.h"
#include <bits/stdc++.h>  

using namespace std;
#define forn(i, n) for (int i = 0; i < int(n); i++)
#define re return
#define fi first
#define mp make_pair
#define se second
#define sz(a) (int)a.size()
#define prev previ
#define tm tmmm
#define div divv

typedef long long ll;
typedef pair<ll, ll> pll;
typedef pair<int, int> pii;

const double pi = acos(-1.);



int n, m, k;
vector<double> dst[10000];
vector<pair<int, int> > pnts;
double a, b;

double dist(pair<int, int> a) {
	re sqrt(double(a.fi * a.fi) + double(a.se * a.se));
}

struct edge {
	double ang;
	double len;
	int to;
	int num;
	edge() {
		ang = 0;
		len = 0;
		to = -1;
	}
	edge(pair<int, int> np1, double len1, int to1) {
		ang = atan2(np1.se, np1.fi);
		len = len1 * a;
		to = to1;
		num = -1;
	}
};

vector<edge> e[10000];

bool cmp(edge a, edge b) {
	re a.ang < b.ang;
}

void do_sort(vector<edge> &a) {
	sort(a.begin(), a.end(), cmp);
}

set<pair<double, pair<int, int> > > dej;

void relax(int i, int j, double d) {
	if (dst[i][j] > d + (1e-9)) {
		dej.erase(mp(dst[i][j], mp(i, j)));
		dst[i][j] = d;
		dej.insert(mp(dst[i][j], mp(i, j)));
	}
}

double get_cost(double ang1, double ang2) {
	double angle = ang1 - ang2;
	if (angle < 0) angle += 2. * pi;
	re min(angle, 2. * pi - angle) * b / (2. * pi);
}

int main() {
	iostream::sync_with_stdio(0), cin.tie(0);
	cin >> n >> m >> k >> a >> b;
	pnts.resize(n);
	forn (i, n) {
		cin >> pnts[i].fi >> pnts[i].se;
	}
	forn (i, m) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		pair<int, int> go = mp(pnts[b].fi - pnts[a].fi, pnts[b].se - pnts[a].se);
		e[a].push_back(edge(go, dist(go), b));
		e[b].push_back(edge(go, dist(go), -a-1));
		e[a][sz(e[a]) - 1].num = sz(e[b]) - 1;
		e[b][sz(e[b]) - 1].num = sz(e[a]) - 1;
		go.fi = -go.fi; go.se = -go.se;
		e[b].push_back(edge(go, dist(go), a));
		e[a].push_back(edge(go, dist(go), -b-1));
		e[a][sz(e[a]) - 1].num = sz(e[b]) - 1;
		e[b][sz(e[b]) - 1].num = sz(e[a]) - 1;
	}
	vector<int> nums;
	nums.resize(k);
	forn (i, k) {
		cin >> nums[i];
		nums[i]--;
	}
	forn (i, n) {
		do_sort(e[i]);
		forn (j, sz(e[i])) {
			auto v = e[i][j];
			if (v.to < 0) {
				e[-v.to-1][v.num].num = j;	
			} else
				e[v.to][v.num].num = j;
		}
		//exit(0);
	}
	/*
	forn (i, n) {
		forn (j, sz(e[i])) {
			cout << e[i][j].to + 1 << "." << e[i][j].num << "." << e[i][j].np.fi << ".." << e[i][j].np.se << "   ";
		}
		cout << "\n";
	}
	exit(0);*/
	forn (i, n) {
		dst[i].assign(sz(e[i]), 0.0000000000000000000000000);
	}	
	cout.precision(30);
	nums.push_back(nums[0]);
	k++;
	//exit(0);
	forn (i, k) {
		int v = nums[i];
		if (i == k - 1) {
			double ans = double(1e14);
			forn (j, sz(e[v])) {
				ans = min(ans, dst[v][j]);
			}
			cout << ans << "\n";
			re 0;
		}
		dej.clear();		
		forn (i, n) {
			forn (j, sz(e[i])) {
				if (i != v) dst[i][j] = double(1e14);
				dej.insert(mp(dst[i][j], mp(i, j)));
			}
		}
		while (!dej.empty()) {
			auto v = (*dej.begin());
			dej.erase(dej.begin());
			if (e[v.se.fi][v.se.se].to >= 0) {
				relax(e[v.se.fi][v.se.se].to, e[v.se.fi][v.se.se].num, v.fi + e[v.se.fi][v.se.se].len);
			}
			relax(v.se.fi, (v.se.se + 1) % sz(e[v.se.fi]), v.fi + get_cost(e[v.se.fi][(v.se.se + 1) % sz(e[v.se.fi])].ang, e[v.se.fi][v.se.se].ang));
			relax(v.se.fi, (v.se.se + sz(e[v.se.fi]) - 1) % sz(e[v.se.fi]), v.fi + get_cost(e[v.se.fi][(v.se.se + sz(e[v.se.fi]) - 1) % sz(e[v.se.fi])].ang, e[v.se.fi][v.se.se].ang));
		}
	}
}