#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

int MOD;
int binpow (int a, int n) {
	int res = 1;
	while (n) {
		if (n & 1)
			res = (1LL * res * a) % MOD;
		a = (1LL * a * a) % MOD;
		n >>= 1;
	}
	return res;
}
const int BUBEN = 32000;

int sb[BUBEN + 1], sc[BUBEN + 1];
int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int l, r;
    cin >> l >> r >> MOD;
    for (int i = 0; i <= BUBEN; i++) {
        sb[i] = 1;
    }
    for (int i = l; i <= r; i++) {
        int bid = (i - l) / BUBEN;
        sb[bid] = ((ll)sb[bid] * i) % MOD;
    }
    for (int i = BUBEN - 2; i >= 0; i--) {
        sb[i] = (ll)sb[i + 1] * sb[i] % MOD;
    }
    int total = binpow(sb[0], MOD - 2);
    int lb = 0, rb = (r - l) / BUBEN;
    int ans = 0;
    int pm = 1;
    for (int bid = lb; bid <= rb; bid++) {
        int lv = BUBEN * bid + l;
        sc[BUBEN] = sb[bid + 1];
        for (int i = BUBEN - 1; i >= 0; i--) {
            sc[i] = sc[i + 1];
            if (i + lv >= l && i + lv <= r) {
                sc[i] = ((ll)sc[i] * (i + lv)) % MOD;
            }
        }
        for (int i = 0; i < BUBEN; i++) {
            if (lv + i >= l && lv + i <= r) { 
                ans += (ll)pm * sc[i + 1] % MOD;
                if (ans >= MOD) {
                    ans -= MOD;
                }
                pm = (ll)pm * (i + lv) % MOD;
            }
        }
    }
    ans = (ll)ans * total % MOD;
    
    cout << ans << endl;
}
