#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <cmath>
#include "testlib.h"

using namespace std;

const int MAXN = 1000;
const int MAXM = 1000;
const int MAXQ = (int)1e6;

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    
    int n = inf.readInt(1, MAXN, "n");
    inf.readSpace();
    int m = inf.readInt(1, MAXM, "m");
    inf.readSpace();
    int q = inf.readInt(1, MAXQ, "q");
    inf.readEoln();
    
    for (int i = 0; i < n; ++i) {
        string ss = inf.readToken();
        ensuref((int)ss.size() == m, "c_i");
        for (int j = 0; j < m; ++j) {
            int c_ij = (int)ss[j] - 48;
            ensuref(0 <= c_ij && c_ij <= 1, "0 <= c_ij <= 1");
        }
        inf.readEoln();
    }
    while (q--) {
        int x = inf.readInt(0, n - 1, "x");
        inf.readSpace();
        int y = inf.readInt(0, m - 1, "y");
        inf.readSpace();
        int dir = inf.readInt(1, 4, "dir");
        inf.readEoln();
    }
    
    inf.readEof();
    
    return 0;
}

