#include "testlib.h"
#include <string>
using namespace std;

const int MAXN = 1e3;

template<typename T>
string str(const T& x) 
{
    stringstream ss;
    ss << x;
    return ss.str();
}


int main(int argc, char * argv[]) 
{
    registerValidation(argc, argv);
    string line = inf.readToken();
    int a, b;
    ensuref(sscanf(line.c_str(), "%d:%d", &a, &b) == 2, "Wrong format");
    ensuref(a >= 0 && a <= MAXN, "Incorrect a");
    ensuref(b >= 0 && b <= MAXN, "Incorrect b");
    inf.readEoln();
    inf.readEof();
    return 0;
}