#include "bits/stdc++.h"
#include "testlib.h"
#define puba push_back
#define mapa make_pair
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int MAXN = 1e6 + 5;

vector<int> graph[MAXN], here[MAXN];

vector<int> order;

int dfs(int v) {
    for (int to : graph[v]) {
        dfs(to);
    }
    order.puba(v);
    return 0;
}

int arr[MAXN];

ll calc(int l, int r) {
    if (l + 1 == r) {
        return 0;
    }
    int m = (l + r) / 2;
    ll ret = calc(l, m) + calc(m, r);
    int c1 = l, c2 = m;
    int c3 = 0;
    while (c1 < m || c2 < r) {
        if (c1 == m || (c2 < r && order[c2] < order[c1])) {
            arr[c3++] = order[c2++];
        } else {
            ret += c2 - m;
            arr[c3++] = order[c1++];
        }
    }
    for (int i = 0; i < r - l; ++i) {
        order[i + l] = arr[i];
    }
    return ret;
}

int main(int argc, char * argv[]) {
    registerTestlibCmd(argc, argv);
    
    int n = inf.readInt();
    int root = inf.readInt() - 1;
    for (int i = 0; i < n; ++i) {
        int num = inf.readInt();
        for (int j = 0; j < num; ++j) {
            int v = inf.readInt() - 1;
            here[i].puba(v);
        }
    }
    
    ll jans = ans.readLong();
    ll pans = ouf.readLong();

    for (int i = 0; i < n; ++i) {
        int num = ouf.readInt();
        for (int j = 0; j < num; ++j) {
            int v = ouf.readInt() - 1;
            graph[i].puba(v);
        }
        auto tmp = graph[i];
        sort(bend(tmp));
        sort(bend(here[i]));
        if (tmp != here[i]) {
            quitf(_wa, "%d-th node has different children", i + 1);
        }
    }

    dfs(root);

    ll val = calc(0, n);
    if (val != pans) {
        quitf(_wa, "number of inversions was calculated wrong, %lld instead of %lld", pans, val);
    }

    if (pans < jans) {
        quitf(_fail, "participant has better solution");
    }

    if (pans > jans) {
        quitf(_wa, "solution isn't optimal");
    }

    quitf(_ok, "solution is correct");

    return 0;
}