#include "bits/stdc++.h"
#include "testlib.h"
#define puba push_back
#define mapa make_pair
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const double PI = atan2(0, -1);
const int MAXN = 1e6 + 5;
const int MAXP = 7;

vector<int> graph[MAXN];

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    assert(argc > 3);

    int n = atoi(argv[1]);
    int from = atoi(argv[2]);
    int to = atoi(argv[3]);
    
    vector<int> order;
    for (int i = 0; i < n; ++i) {
        order.puba(i);
    }

    shuffle(bend(order));

    int c = 0;
    int root = order[c++];

    set<pii> all;
    all.insert({rnd.next(0, INF), root});

    for (int i = 1; i < n; ++i) {
        int cur = all.begin()->ss;
        all.erase(all.begin());
        int cur_from = min(from, n - c), cur_to = min(to, n - c);
        int children = rnd.next(cur_from, cur_to);
        if (c < n && !szof(all) && children == 0) {
            children = rnd.next(1, cur_to);
        }
        for (int j = 0; j < children; ++j) {
            all.insert({rnd.next(0, INF), order[c]});
            graph[cur].puba(order[c++]);
        }
    }

    cout << n << " " << root + 1 << "\n";

    for (int i = 0; i < n; ++i) {
        cout << szof(graph[i]);
        for (int to : graph[i]) {
            cout << " " << to + 1;
        }
        cout << "\n";
    }

    return 0;
}