#include "bits/stdc++.h"
#include "testlib.h"
#define puba push_back
#define mapa make_pair
#define ff first
#define ss second
#define bend(_x) (_x).begin(), (_x).end()
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int MAXN = 200000, MAXP = 7;

int parent[MAXN];
bool used[MAXN];
vector<int> graph[MAXN];

int dfs(int v) {
    used[v] = true;
    for (int to : graph[v]) {
        dfs(to);
    }
    return 0;
}

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);

    int n = inf.readInt(1, MAXN, "n");
    inf.readSpace();
    int root = inf.readInt(1, n, "root") - 1;
    inf.readEoln();
    
    int sum = 0;
    fill(parent, parent + n, -1);
    for (int i = 0; i < n; ++i) {
        int num = inf.readInt(0, MAXP, "num");
        sum += num;
        for (int j = 0; j < num; ++j) {
            inf.readSpace();
            int to = inf.readInt(1, n, "to") - 1;
            parent[to] = i;
            graph[i].puba(to);
        }
        inf.readEoln();
    }
    inf.readEof();

    ensuref(sum == n - 1, "graph must be tree");

    ensuref(parent[root] == -1, "root isn't a root");

    dfs(root);

    for (int i = 0; i < n; ++i) {
        ensuref(used[i], "tree must be connected");
    }

    return 0;
}