//#include "grader.h"
#include <bits/stdc++.h>  

using namespace std;
#define forn(i, n) for (int i = 0; i < int(n); i++)
#define re return
#define fi first
#define mp make_pair
#define se second
#define sz(a) (int)a.size()
#define prev previ
#define tm tmmm
#define div divv
typedef long long ll;
typedef pair<ll, ll> pll;
typedef pair<int, int> pii;
const ll inf = ll(1e13);
//const ll mod = ll(1e9) + 9LL, pr = 239, mod2 = ll(1e9) + 7;
//const int ma = 128 * 1024;

ll n, r, ans = 0, dp[(1 << 7)], pr[(1 << 7)], cnt[7][7];
vector<int> e[200000], ne[200000];

struct node
{
	node *l, *r;
	int key, pr, szz;
	node() {
		key = szz = 0;
		pr = rand();
		l = r = NULL;
	}	
	node(int k) {
		key = k;
		szz = 1;
		pr = rand();
		l = r = NULL;
	}
};

typedef node * treap;

int get_size(treap a) {
	if (a == NULL) re 0;
	re a->szz;
}

void upd(treap &a) {
	if (a == NULL) re;
	a->szz = get_size(a->l) + get_size(a->r) + 1;
}

ll get_cnt(treap b, int k) {
	if (b == NULL) re 0;
	if ((b->key) > k)
		re get_cnt(b->l, k);
	else
		re get_cnt((b->r), k) + 1 + get_size(b->l);
}

ll get_(treap a, treap b) {
	if (a == NULL) re 0;
	re get_cnt(b, a->key) + get_(a->l, b) + get_(a->r, b);
}

void split(treap a, treap &l, treap &r, int key) {
	if (a == NULL) {
		l = r = NULL;
		re;
	}
	if ((a->key) < key) {
		split((a->r), (a->r), r, key);
		l = a;
	}
	else {
		split((a->l), l, (a->l), key);
		r = a;
	}
	upd(a);
	upd(l);
	upd(r);
}

void insert(treap &a, treap b) {
	if (a == NULL) {
		a = b;
		re;
	}
	if ((a->pr) > (b->pr)) {
		split(a, b->l, b->r, b->key);
		a = b;
	} else {
		if ((a->key) > (b->key)) {
			insert(a->l, b);
		} else
			insert(a->r, b);
	}
	upd(b);
	upd(a);
}


void out(treap a) {
	if (a == NULL) re;
	out(a->l);
	cout << (a->key) + 1 << " ";
	out(a->r);
}
void add_elements(treap &a, treap b) {
	if (b == NULL) re;
	/*out(a);
	cout << "\n";
	out(b);
	cout << "\n";*/
	add_elements(a, (b->l));
	add_elements(a, (b->r));
	b->l = b->r = NULL;
	insert(a, b);
	
}

void dfs(int nu, treap &a) {
	a = NULL;
	vector<treap> c;
	forn (j, sz(e[nu])) {
		treap q = NULL;
		dfs(e[nu][j], q);
		c.push_back(q);
	}
	int k = sz(e[nu]);
	forn (i, k) {
		forn (j, k) {
			cnt[i][j] = 0;
		}
	}
	forn (i, k) {
		for (int j = i + 1; j < k; j++) {
			if (get_size(c[i]) < get_size(c[j])) {
				cnt[i][j] = get_(c[i], c[j]);
				cnt[j][i] = ll(get_size(c[i])) * ll(get_size(c[j])) - cnt[i][j];
			} else {
				cnt[j][i] = get_(c[j], c[i]);
				cnt[i][j] = ll(get_size(c[i])) * ll(get_size(c[j])) - cnt[j][i];
			}
		}
	}
	dp[0] = 0;
	for (int i = 1; i < (1 << k); i++) {
		dp[i] = ll(1e10);
		forn(j, k) {
			if (i & (1 << j)) {
				ll c = dp[i ^ (1 << j)];
				forn (q, k)
					if (i & (1 << q))
						c += cnt[q][j];
				dp[i] = min(dp[i], c);
				if (dp[i] == c) {
					pr[i] = j;
				}
			}
		}
	}
	
	int nuk = (1 << k)  -1;
	while (nuk > 0) {
		ne[nu].push_back(e[nu][pr[nuk]]);
		nuk ^= (1 << pr[nuk]);
	}
	reverse(ne[nu].begin(), ne[nu].end());
	ans += dp[(1 << k) - 1];
	//if (nu + 1 == 2) exit(0);
	forn (i, k) {
		/*out(a);
		cout << "\n";
		out(c[i]);
		cout << "\n";*/
		if (get_size(a) < get_size(c[i])) {
			swap(a, c[i]);
		}
		/*out(a);
		cout << "\n";
		out(c[i]);
		cout << "\n\n";*/
		add_elements(a, c[i]);
		//exit(0);
	}
	ans += get_size(a) - get_cnt(a, nu);
	insert(a, new node(nu));
}

int main() {
	iostream::sync_with_stdio(0), cin.tie(0);
	cin >> n >> r;
	r--;
	forn (i, n) {
		int k;
		cin >> k;
		e[i].resize(k);
		forn (j, k) {
			cin >> e[i][j];
			e[i][j]--;
		}
	}
	treap a = NULL;
	dfs(r, a);
	cout << ans << "\n";
	forn (i, n) {
		cout << sz(ne[i]) << " ";
		for (auto v : ne[i]) cout << v+ 1 << " ";
		cout << "\n";
	}
}