#include <bits/stdc++.h>

const int maxn = 1010;

int n, m, q;
int id;
int field[maxn][maxn];
bool used[maxn * maxn];
int dx[] = {1, -1, 0, 0};
int dy[] = {0, 0, 1, -1};

void dfs(int x, int y, int x1, int y1, int x2, int y2, int nid) {
  field[x][y] = nid;
  for (int i = 0; i < 4; i++) {
    int nx = x + dx[i];
    int ny = y + dy[i];
    if (nx < 1 || nx > n || ny < 1 || ny > m || ((nx == x1 || nx == x2) && y1 <= ny && ny <= y2) || ((ny == y1 || ny == y2) && x1 <= nx && nx <= x2) || field[nx][ny] == -1) {
      continue;
    }
    if (field[nx][ny] != nid) {
      dfs(nx, ny, x1, y1, x2, y2, nid);
    }
  }
}

int main() {
  scanf("%d%d%d", &n, &m, &q);
  for (int i = 1; i <= n; i++) {
    for (int j = 1; j <= m; j++) {
      field[i][j] = 1;
    }
  }
  id = 2;
  int comps = 1;
  for (int i = 0; i < q; i++) {
    int x1, y1, x2, y2;
    scanf("%d%d%d%d", &x1, &y1, &x2, &y2);
    int oldid = id;
    for (int x = x1 - 1; x <= x2 + 1; x++) {
      for (int y = y1 - 1; y <= y2 + 1; y++) {
        if (x < 1 || x > n || y < 1 || y > m) {
          continue;
        }
        if (field[x][y] == -1 || field[x][y] >= oldid) {
          continue;
        }
        if (!used[field[x][y]]) {
          used[field[x][y]] = true;
          comps--;
        }
        if (((x == x1 || x == x2) && y1 <= y && y <= y2) || ((y == y1 || y == y2) && x1 <= x && x <= x2)) {
          field[x][y] = -1;
          continue;
        }
        comps++;
        int nid = id++;
        dfs(x, y, x1, y1, x2, y2, nid);
      }
    }
    printf("%d\n", comps);
  }
}