#include "testlib.h"
#include <algorithm>
#include <set>
using namespace std;

const int MAXN = (int)1e5;
const int MAX = (int)1e9;

int main(int argc, char **argv) 
{
    registerValidation(argc, argv);
    set <string> operations;
    operations.insert("OR");
    operations.insert("AND");

    int n = inf.readInt(1, MAXN, "n");
    inf.readEoln();

    for (int i = 0; i < n; i++)
    {
        int f_i = inf.readInt(0, MAX, "f_i");
        if (i < n - 1)
            inf.readSpace();
    }
    inf.readEoln();

    int m = inf.readInt(1, MAXN, "m");
    inf.readEoln();

    for (int i = 0; i < m; i++)
    {
        string operation = inf.readToken();
        inf.readSpace();
        if (operations.find(operation) == operations.end())
            quitf(_fail, "Illegal operation %s at line %d\n", operation.c_str(), i);
        int x = inf.readInt(0, MAX, "x");
        inf.readEoln();
    }

    inf.readEof();

    return 0;
}