#include "bits/stdc++.h"
#define puba push_back
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }

struct point {
    double x, y;
    point() : x(0), y(0) {}
    point(double _x, double _y) : x(_x), y(_y) {}
    double len() {
        return sqrt(x * x + y * y);
    }
    double ang() {
        return atan2(y, x);
    }
    point operator-(point p) {
        return point(x - p.x, y - p.y);
    }
};

vector<vector<pair<int, double>>> graph;
vector<double> dist;

int add_node() {
    graph.puba({});
    return szof(graph) - 1;
}

int add_edge(int a, int b, double l) {
    graph[a].puba({b, l});
    return 0;
}

double get_ang(double ang1, double ang2) {
    double tmp = ang2 - ang1;
    if (tmp < 0) {
        tmp += PI * 2;
    }
    return tmp;
}

int main() {
    //freopen(TASK_NAME ".in", "r", stdin);
    //freopen(TASK_NAME ".out", "w", stdout);
    cerr << fixed << setprecision(15);
    cout << fixed << setprecision(15);
    
    int n, m, k, ca, tcb;
    scanf("%d%d%d%d%d", &n, &m, &k, &ca, &tcb);
    double cb = tcb / PI / 2;

    vector<point> coords;

    for (int i = 0; i < n; ++i) {
        int x, y;
        scanf("%d%d", &x, &y);
        coords.puba(point(x, y));
    }
    
    vector<pii> edges;
    for (int i = 0; i < m; ++i) {
        int a, b;
        scanf("%d%d", &a, &b);
        --a; --b;
        edges.puba({a, b});
    }

    vector<int> order;
    for (int i = 0; i < k; ++i) {
        int v;
        scanf("%d", &v);
        --v;
        order.puba(v);
    }

    int from = add_node();
    int to = add_node();

    vector<vector<tuple<int, int, double, double>>> here(n);
    vector<tuple<int, int, double>> ledges;
    for (auto e : edges) {
        int a = add_node();
        //int b = add_node();
        //int c = add_node();
        int d = add_node();

        double l = (coords[e.ff] - coords[e.ss]).len();
        here[e.ff].emplace_back(e.ss, a, (coords[e.ss] - coords[e.ff]).ang(), l * ca);
        //here[e.ff].puba({b, (coords[e.ff] - coords[e.ss]).ang()});
        //here[e.ss].puba({c, (coords[e.ss] - coords[e.ff]).ang()});
        here[e.ss].emplace_back(e.ff, d, (coords[e.ff] - coords[e.ss]).ang(), l * ca);
        
        /*
        add_edge(d, b, l * ca);
        ledges.emplace_back(d, b, l * ca);
        add_edge(a, c, l * ca);
        ledges.emplace_back(a, c, l * ca);
        */
    }

    for (int j = 0; j < n; ++j) {
        sort(bend(here[j]), [](tuple<int, int, double, double> p1, tuple<int, int, double, double> p2) {
            return get<2>(p1) < get<2>(p2);
        });
    }

    for (int j = 0; j < n; ++j) {
        for (int j2 = 0; j2 < szof(here[j]); ++j2) {
            int v, ind;
            double ang, len;
            tie(v, ind, ang, len) = here[j][j2];

            {
                int l = -1, r = szof(here[v]);
                while (r - l > 1) {
                    int mid = (l + r) / 2;
                    if (get<2>(here[v][mid]) < ang) {
                        l = mid;
                    } else {
                        r = mid;
                    }
                }

                l = (l + szof(here[v])) % szof(here[v]);
                r = r % szof(here[v]);

                double tmp = len + get_ang(get<2>(here[v][l]), ang) * cb;
                add_edge(ind, get<1>(here[v][l]), tmp);
                ledges.emplace_back(ind, get<1>(here[v][l]), tmp);
                tmp = len + get_ang(ang, get<2>(here[v][r])) * cb;
                add_edge(ind, get<1>(here[v][r]), tmp);
                ledges.emplace_back(ind, get<1>(here[v][r]), tmp);
            }

            int next = (j2 + 1 == szof(here[j]) ? 0 : j2 + 1);
            double l = get_ang(ang, get<2>(here[j][next]));
            if (order[0] == j) {
                add_edge(from, ind, 0);
            }
            int tov = get<1>(here[j][next]);
            add_edge(ind, tov, l * cb);
            ledges.emplace_back(ind, tov, l * cb);
            add_edge(tov, ind, l * cb);
            ledges.emplace_back(tov, ind, l * cb);
        }
    }

    for (int i = 1; i < k; ++i) {
        graph.resize(szof(graph) + m * 2);
        for (auto t : ledges) {
            int a, b;
            double l;
            tie(a, b, l) = t;
            add_edge(a + i * m * 2, b + i * m * 2, l);
        }
        for (int j = 0; j < n; ++j) {
            for (int j2 = 0; j2 < szof(here[j]); ++j2) {
                int v = get<1>(here[j][j2]);
                if (order[i] == j) {
                    add_edge(v - m * 2 + i * m * 2, v + i * m * 2, 0);
                }
                if (i == k - 1 && order[0] == get<0>(here[j][j2])) {
                    add_edge(v + i * m * 2, to, get<3>(here[j][j2]));
                }
            }
        }
    }

    /*
    cerr << szof(graph) << endl;
    for (int i = 0; i < szof(graph); ++i) {
        for (auto tov : graph[i]) {
            cerr << i << " " << tov.ff << " " << tov.ss << endl;
        }
    }
    */

    cerr << szof(graph) << endl;

    dist.resize(szof(graph), 1e100);
    dist[from] = 0;
    set<pair<double, int>> st;
    st.insert({0, from});
    while (szof(st)) {
        int v = st.begin() -> ss;
        st.erase(st.begin());
        for (auto tov : graph[v]) {
            if (dist[tov.ff] > dist[v] + tov.ss) {
                st.erase({dist[tov.ff], tov.ff});
                dist[tov.ff] = dist[v] + tov.ss;
                st.insert({dist[tov.ff], tov.ff});
            }
        }
    }

    cout << dist[to] << "\n";
    
    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}