#include "bits/stdc++.h"
#define puba push_back
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }

struct point {
    double x, y;
    point() : x(0), y(0) {}
    point(double _x, double _y) : x(_x), y(_y) {}
    double len() {
        return sqrt(x * x + y * y);
    }
    double ang() {
        return atan2(y, x);
    }
    point operator-(point p) {
        return point(x - p.x, y - p.y);
    }
};

vector<vector<pair<int, double>>> graph;
vector<double> dist;

int add_node() {
    graph.puba({});
    return szof(graph) - 1;
}

int add_edge(int a, int b, double l) {
    graph[a].puba({b, l});
    return 0;
}

int main() {
    //freopen(TASK_NAME ".in", "r", stdin);
    //freopen(TASK_NAME ".out", "w", stdout);
    cerr << fixed << setprecision(15);
    cout << fixed << setprecision(15);
    
    int n, m, k, ca, tcb;
    scanf("%d%d%d%d%d", &n, &m, &k, &ca, &tcb);
    double cb = tcb / PI / 2;

    vector<point> coords;

    for (int i = 0; i < n; ++i) {
        int x, y;
        scanf("%d%d", &x, &y);
        coords.puba(point(x, y));
    }
    
    vector<pii> edges;
    for (int i = 0; i < m; ++i) {
        int a, b;
        scanf("%d%d", &a, &b);
        --a; --b;
        edges.puba({a, b});
    }

    vector<int> order;
    for (int i = 0; i < k; ++i) {
        int v;
        scanf("%d", &v);
        --v;
        order.puba(v);
    }

    int from = add_node();
    int to = add_node();

    for (int i = 0; i < k; ++i) {
        vector<vector<pair<int, double>>> here(n);
        for (auto e : edges) {
            int a = add_node();
            int b = add_node();
            int c = add_node();
            int d = add_node();
            here[e.ff].puba({a, (coords[e.ss] - coords[e.ff]).ang()});
            here[e.ff].puba({b, (coords[e.ff] - coords[e.ss]).ang()});
            here[e.ss].puba({c, (coords[e.ss] - coords[e.ff]).ang()});
            here[e.ss].puba({d, (coords[e.ff] - coords[e.ss]).ang()});
            double l = (coords[e.ff] - coords[e.ss]).len();
            add_edge(d, b, l * ca);
            add_edge(a, c, l * ca);
        }

        for (int j = 0; j < n; ++j) {
            sort(bend(here[j]), [](pair<int, double> p1, pair<int, double> p2) {
                return p1.ss < p2.ss;
            });
            for (int j2 = 0; j2 < szof(here[j]); ++j2) {
                int next = (j2 + 1 == szof(here[j]) ? 0 : j2 + 1);
                double l = here[j][next].ss - here[j][j2].ss;
                if (l < 0) {
                    l += PI * 2;
                }
                add_edge(here[j][j2].ff, here[j][next].ff, l * cb);
                add_edge(here[j][next].ff, here[j][j2].ff, l * cb);
                if (i < k && order[i] == j) {
                    if (i == 0) {
                        add_edge(from, here[j][j2].ff, 0);
                    } else {
                        add_edge(here[j][j2].ff - m * 4, here[j][j2].ff, 0);
                    }
                }
                if (i == k - 1 && order[0] == j) {
                    add_edge(here[j][j2].ff, to, 0);
                }
            }
        }
    }

    dist.resize(szof(graph), 1e100);
    dist[from] = 0;
    set<pair<double, int>> st;
    st.insert({0, from});
    while (szof(st)) {
        int v = st.begin() -> ss;
        st.erase(st.begin());
        for (auto to : graph[v]) {
            if (dist[to.ff] > dist[v] + to.ss) {
                st.erase({dist[to.ff], to.ff});
                dist[to.ff] = dist[v] + to.ss;
                st.insert({dist[to.ff], to.ff});
            }
        }
    }

    cout << dist[to] << "\n";
    
    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}