/**
 *    author:  [itmo] enot.1.10
 *    created: 10.11.2017 14:14:45       
**/
#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define forn(i, n) for(int i = 0 ; (i) < (n) ; ++i)
#define eprintf(...) fprintf(stderr, __VA_ARGS__),fflush(stderr)
#define sz(a) ((int)(a).size())
#define all(a) (a).begin(),a.end()
#define pw(x) (1LL<<(x))

using namespace std;

typedef long long ll;
typedef double dbl;
typedef vector<int> vi;
typedef pair<int, int> pi;

const int inf = 1.01e9;
const dbl eps = 1e-9;


int mpow(int a, int b, int mod)
{
    int res = 1;
    while (b)
    {
        if (b & 1) res = (res * (ll)a) % mod;
        a = (a * (ll)a) % mod;
        b >>= 1;
    }
    return res;
}

int main()
{
    #ifdef home
        assert(freopen("1.in", "r", stdin));
        assert(freopen("1.out", "w", stdout));
    #endif
    int l, r, p;
    scanf("%d%d%d", &l, &r, &p);
    int A = 0, B = 1;
    for (int i = l; i <= r; ++i)
    {
        A = (A * (ll)i + B) % p;
        B = B * (ll)i % p;
    }
    int res = A * (ll)mpow(B, p - 2, p) % p;
    printf("%d\n", res);
    #ifdef home
        eprintf("time = %d ms\n", (int)(clock() * 1000. / CLOCKS_PER_SEC));
    #endif
    return 0;
}
